Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.transaction.jta
Class JotmFactoryBean

    java.lang.Object
      org.springframework.transaction.jta.JotmFactoryBean

All Implemented Interfaces:
  DisposableBean, FactoryBean

    public class JotmFactoryBean

extends Object
implements FactoryBean, DisposableBean

FactoryBean that retrieves the JTA UserTransaction/TransactionManager for ObjectWeb's JOTM. Will retrieve an already active JOTM instance if found (e.g. if running in JOnAS), else create a new local JOTM instance.

With JOTM, the same object implements both the `UserTransaction` and the `TransactionManager` interface, as returned by this FactoryBean.

A local JOTM instance is well-suited for working in conjunction with ObjectWeb's XAPool, e.g. with bean definitions like the following:

     <bean id="jotm" class="org.springframework.transaction.jta.JotmFactoryBean"/>

     <bean id="transactionManager" class="org.springframework.transaction.jta.JtaTransactionManager">
       <property name="userTransaction" ref="jotm"/>
     </bean>

     <bean id="innerDataSource" class="org.enhydra.jdbc.standard.StandardXADataSource" destroy-method="shutdown">
       <property name="transactionManager" ref="jotm"/>
       <property name="driverName" value="..."/>
       <property name="url" value="..."/>
       <property name="user" value="..."/>
       <property name="password" value="..."/>
     </bean>

     <bean id="dataSource" class="org.enhydra.jdbc.pool.StandardXAPoolDataSource" destroy-method="shutdown">
       <property name="dataSource" ref="innerDataSource"/>
       <property name="user" value="..."/>
       <property name="password" value="..."/>
       <property name="maxSize" value="..."/>
     </bean>

Note that Spring's `JtaTransactionManager` will automatically detect that the passed-in UserTransaction reference also implements the TransactionManager interface. Hence, it is not necessary to specify a separate reference for JtaTransactionManager's "transactionManager" property.

Implementation note: This FactoryBean uses JOTM's static access method to obtain the JOTM `Current` object, which implements both the UserTransaction and the TransactionManager interface, as mentioned above.

Since:
  21.01.2004
Author:
  Juergen Hoeller
See Also:
  `JtaTransactionManager.setUserTransaction(javax.transaction.UserTransaction)`, `JtaTransactionManager.setTransactionManager(javax.transaction.TransactionManager)`, `Current`

Constructor Summary
`JotmFactoryBean()`

Method Summary
`void` | `destroy()` Stop the local JOTM instance, if created by this FactoryBean.
`org.objectweb.jotm.Jotm` | `getJotm()` Return the JOTM instance created by this factory bean, if any.
`Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton?
`void` | `setDefaultTimeout(int defaultTimeout)` Set the default transaction timeout for the JOTM instance.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JotmFactoryBean

    public JotmFactoryBean()
                    throws NamingException

Throws:
  `NamingException`

Method Detail

### setDefaultTimeout

    public void setDefaultTimeout(int defaultTimeout)

  Set the default transaction timeout for the JOTM instance.

  Should only be called for a local JOTM instance, not when accessing an existing (shared) JOTM instance.

### getJotm

    public org.objectweb.jotm.Jotm getJotm()

  Return the JOTM instance created by this factory bean, if any. Will be `null` if an already active JOTM instance is used.

  Application code should never need to access this.

### getObject

    public Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### destroy

    public void destroy()

  Stop the local JOTM instance, if created by this FactoryBean.

  Specified by:
    `destroy` in interface `DisposableBean`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.